library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;  -- Use OR_REDUCE function

use work.MTriggerpkg.all;

entity QISectClusters is
	port(
		CLK			: in std_logic;
		
		QSUMA		: in STD_LOGIC_VEC_ARRAY4_37;
		QSUMB		: in STD_LOGIC_VEC_ARRAY4_37;
		QSUMC		: in STD_LOGIC_VEC_ARRAY4_37;
		
		THRESHOLD	: in std_logic_vector(3 downto 0);
		
		QICLUSTERSB	: in std_logic_vector(18 downto 0);
		QOCLUSTERSB	: out std_logic_vector(36 downto 0)
	);
end QISectClusters;

architecture RTL of QISectClusters is
	signal QCLUSTERSB_D	: std_logic_vector(36 downto 0);
begin

	QCLUSTERSB_D(0) <= '1' when QSUMB(0) > THRESHOLD and QSUMB(0) > QSUMB(1) and QSUMB(0) > QSUMB(3) and
								QSUMB(0) > QSUMB(2) and QSUMB(0) >= QSUMA(35) and QSUMB(0) >= QSUMA(36) else '0';

	QCLUSTERSB_D(2) <= '1' when QSUMB(2) > THRESHOLD and QSUMB(2) > QSUMB(1) and QSUMB(2) > QSUMB(3) and
								QSUMB(2) > QSUMB(5) and QSUMB(2) > QSUMB(4) and QSUMB(2) >= QSUMA(34) and
								QSUMB(2) >= QSUMA(35) and QSUMB(2) > QSUMA(36) and QSUMB(2) >= QSUMB(0) else '0';
								
	QCLUSTERSB_D(4) <= '1' when QSUMB(4) > THRESHOLD and QSUMB(4) > QSUMB(3) and QSUMB(4) > QSUMB(5) and
								QSUMB(4) > QSUMB(7) and QSUMB(4) > QSUMB(6) and QSUMB(4) >= QSUMA(33) and
								QSUMB(4) >= QSUMA(34) and QSUMB(4) > QSUMA(35) and QSUMB(4) >= QSUMB(2) else '0';

	QCLUSTERSB_D(6) <= '1' when QSUMB(6) > THRESHOLD and QSUMB(6) > QSUMB(5) and QSUMB(6) > QSUMB(7) and
								QSUMB(6) > QSUMB(9) and QSUMB(6) > QSUMB(8) and QSUMB(6) >= QSUMA(32) and
								QSUMB(6) >= QSUMA(33) and QSUMB(6) > QSUMA(34) and QSUMB(6) >= QSUMB(4) else '0';

	QCLUSTERSB_D(8) <= '1' when QSUMB(8) > THRESHOLD and QSUMB(8) > QSUMB(7) and QSUMB(8) > QSUMB(9) and
								QSUMB(8) > QSUMB(11) and QSUMB(8) > QSUMB(10) and QSUMB(8) >= QSUMA(31) and
								QSUMB(8) >= QSUMA(32) and QSUMB(8) > QSUMA(33) and QSUMB(8) >= QSUMB(6) else '0';

	QCLUSTERSB_D(10) <= '1' when QSUMB(10) > THRESHOLD and QSUMB(10) > QSUMB(9) and QSUMB(10) > QSUMB(11) and
								 QSUMB(10) > QSUMB(13) and QSUMB(10) > QSUMB(12) and QSUMB(10) >= QSUMA(30) and
								 QSUMB(10) >= QSUMA(31) and QSUMB(10) > QSUMA(32) and QSUMB(10) >= QSUMB(8) else '0';

	QCLUSTERSB_D(12) <= '1' when QSUMB(12) > THRESHOLD and QSUMB(12) > QSUMB(11) and QSUMB(12) > QSUMB(13) and
								 QSUMB(12) > QSUMB(15) and QSUMB(12) > QSUMB(14) and QSUMB(12) >= QSUMA(29) and
								 QSUMB(12) >= QSUMA(30) and QSUMB(12) > QSUMA(31) and QSUMB(12) >= QSUMB(10) else '0';

	QCLUSTERSB_D(14) <= '1' when QSUMB(14) > THRESHOLD and QSUMB(14) > QSUMB(13) and QSUMB(14) > QSUMB(15) and
								 QSUMB(14) > QSUMB(17) and QSUMB(14) > QSUMB(16) and QSUMB(14) >= QSUMA(28) and
								 QSUMB(14) >= QSUMA(29) and QSUMB(14) > QSUMA(30) and QSUMB(14) >= QSUMB(12) else '0';

	QCLUSTERSB_D(16) <= '1' when QSUMB(16) > THRESHOLD and QSUMB(16) > QSUMB(15) and QSUMB(16) > QSUMB(17) and
								 QSUMB(16) > QSUMB(18) and QSUMB(16) >= QSUMA(28) and QSUMB(16) > QSUMA(29) and
								 QSUMB(16) >= QSUMB(14) else '0';

	QCLUSTERSB_D(28) <= '1' when QSUMB(28) > THRESHOLD and QSUMB(28) > QSUMB(20) and QSUMB(28) > QSUMB(29) and
								 QSUMB(28) > QSUMC(14) and QSUMB(28) >= QSUMC(16) and QSUMB(28) >= QSUMB(19) else '0';

	QCLUSTERSB_D(29) <= '1' when QSUMB(29) > THRESHOLD and QSUMB(29) > QSUMB(21) and QSUMB(29) > QSUMB(30) and
								 QSUMB(29) > QSUMC(12) and QSUMB(29) >= QSUMC(14) and QSUMB(29) >= QSUMC(16) and
								 QSUMB(29) >= QSUMB(28) and QSUMB(29) >= QSUMB(19) and QSUMB(29) >= QSUMB(20) else '0';

	QCLUSTERSB_D(30) <= '1' when QSUMB(30) > THRESHOLD and QSUMB(30) > QSUMB(22) and QSUMB(30) > QSUMB(31) and
								 QSUMB(30) > QSUMC(10) and QSUMB(30) >= QSUMC(12) and QSUMB(30) >= QSUMC(14) and
								 QSUMB(30) >= QSUMB(29) and QSUMB(30) >= QSUMB(20) and QSUMB(30) >= QSUMB(21) else '0';

	QCLUSTERSB_D(31) <= '1' when QSUMB(31) > THRESHOLD and QSUMB(31) > QSUMB(23) and QSUMB(31) > QSUMB(32) and
								 QSUMB(31) > QSUMC(8) and QSUMB(31) >= QSUMC(10) and QSUMB(31) >= QSUMC(12) and
								 QSUMB(31) >= QSUMB(30) and QSUMB(31) >= QSUMB(21) and QSUMB(31) >= QSUMB(22) else '0';

	QCLUSTERSB_D(32) <= '1' when QSUMB(32) > THRESHOLD and QSUMB(32) > QSUMB(24) and QSUMB(32) > QSUMB(33) and
								 QSUMB(32) > QSUMC(6) and QSUMB(32) >= QSUMC(8) and QSUMB(32) >= QSUMC(10) and
								 QSUMB(32) >= QSUMB(31) and QSUMB(32) >= QSUMB(22) and QSUMB(32) >= QSUMB(23) else '0';

	QCLUSTERSB_D(33) <= '1' when QSUMB(33) > THRESHOLD and QSUMB(33) > QSUMB(25) and QSUMB(33) > QSUMB(34) and
								 QSUMB(33) > QSUMC(4) and QSUMB(33) >= QSUMC(6) and QSUMB(33) >= QSUMC(8) and
								 QSUMB(33) >= QSUMB(32) and QSUMB(33) >= QSUMB(23) and QSUMB(33) >= QSUMB(24) else '0';

	QCLUSTERSB_D(34) <= '1' when QSUMB(34) > THRESHOLD and QSUMB(34) > QSUMB(26) and QSUMB(34) > QSUMB(35) and
								 QSUMB(34) > QSUMC(2) and QSUMB(34) >= QSUMC(4) and QSUMB(34) >= QSUMC(6) and
								 QSUMB(34) >= QSUMB(33) and QSUMB(34) >= QSUMB(24) and QSUMB(34) >= QSUMB(25) else '0';

	QCLUSTERSB_D(35) <= '1' when QSUMB(35) > THRESHOLD and QSUMB(35) > QSUMB(27) and QSUMB(35) > QSUMB(36) and
								 QSUMB(35) > QSUMC(0) and QSUMB(35) >= QSUMC(2) and QSUMB(35) >= QSUMC(4) and
								 QSUMB(35) >= QSUMB(34) and QSUMB(35) >= QSUMB(25) and QSUMB(35) >= QSUMB(26) else '0';

	QCLUSTERSB_D(36) <= '1' when QSUMB(36) > THRESHOLD and QSUMB(36) >= QSUMC(0) and QSUMB(36) >= QSUMC(2) and
								 QSUMB(36) >= QSUMB(35) and QSUMB(36) >= QSUMB(26) and QSUMB(36) >= QSUMB(27) else '0';


	QCLUSTERSB_D(1) <= '1' when QSUMB(1) > QSUMB(3) and QSUMB(1) >= QSUMB(2) and QSUMB(1) >= QSUMB(0) and 
	                            QICLUSTERSB(0) = '1' else '0';
	
	QCLUSTERSB_D(3) <= '1' when QSUMB(3) > QSUMB(5) and QSUMB(3) >= QSUMB(4) and QSUMB(3) >= QSUMB(2) and
	                            QSUMB(3) >= QSUMB(0) and QSUMB(3) >= QSUMB(1) and QICLUSTERSB(1) = '1' else '0';
	
	QCLUSTERSB_D(5) <= '1' when QSUMB(5) > QSUMB(7) and QSUMB(5) >= QSUMB(6) and QSUMB(5) >= QSUMB(4) and
	                            QSUMB(5) >= QSUMB(2) and QSUMB(5) >= QSUMB(3) and QICLUSTERSB(2) = '1' else '0';
	
	QCLUSTERSB_D(7) <= '1' when QSUMB(7) > QSUMB(9) and QSUMB(7) >= QSUMB(8) and QSUMB(7) >= QSUMB(6) and
	                            QSUMB(7) >= QSUMB(4) and QSUMB(7) >= QSUMB(5) and QICLUSTERSB(3) = '1' else '0';
	
	QCLUSTERSB_D(9) <= '1' when QSUMB(9) > QSUMB(11) and QSUMB(9) >= QSUMB(10) and QSUMB(9) >= QSUMB(8) and
	                            QSUMB(9) >= QSUMB(6) and QSUMB(9) >= QSUMB(7) and QICLUSTERSB(4) = '1' else '0';
	
	QCLUSTERSB_D(11) <= '1' when QSUMB(11) > QSUMB(13) and QSUMB(11) >= QSUMB(12) and QSUMB(11) >= QSUMB(10) and
	                            QSUMB(11) >= QSUMB(8) and QSUMB(11) >= QSUMB(9) and QICLUSTERSB(5) = '1' else '0';
	
	QCLUSTERSB_D(13) <= '1' when QSUMB(13) > QSUMB(15) and QSUMB(13) >= QSUMB(14) and QSUMB(13) >= QSUMB(12) and
	                            QSUMB(13) >= QSUMB(10) and QSUMB(13) >= QSUMB(11) and QICLUSTERSB(6) = '1' else '0';
	
	QCLUSTERSB_D(15) <= '1' when QSUMB(15) > QSUMB(17) and QSUMB(15) >= QSUMB(16) and QSUMB(15) >= QSUMB(14) and
	                            QSUMB(15) >= QSUMB(12) and QSUMB(15) >= QSUMB(13) and QICLUSTERSB(7) = '1' else '0';
	
	QCLUSTERSB_D(17) <= '1' when QSUMB(17) > QSUMB(18) and QSUMB(17) >= QSUMB(16) and QSUMB(17) >= QSUMB(14) and
	                            QSUMB(17) >= QSUMB(15) and QICLUSTERSB(8) = '1' else '0';
	
	QCLUSTERSB_D(18) <= '1' when QSUMB(18) > QSUMB(19) and QSUMB(17) >= QSUMB(17) and QICLUSTERSB(9) = '1' else '0';
	
	QCLUSTERSB_D(19) <= '1' when QSUMB(19) > QSUMB(20) and QSUMB(19) > QSUMB(29) and QSUMB(19) > QSUMB(28) and
	                             QSUMB(19) >= QSUMB(18) and QICLUSTERSB(10) = '1' else '0';

	QCLUSTERSB_D(20) <= '1' when QSUMB(20) > QSUMB(21) and QSUMB(20) > QSUMB(30) and QSUMB(20) > QSUMB(29) and
	                             QSUMB(20) >= QSUMB(28) and QSUMB(20) >= QSUMB(19) and QICLUSTERSB(11) = '1' else '0';

	QCLUSTERSB_D(21) <= '1' when QSUMB(21) > QSUMB(22) and QSUMB(21) > QSUMB(31) and QSUMB(21) > QSUMB(30) and
	                             QSUMB(21) >= QSUMB(29) and QSUMB(21) >= QSUMB(20) and QICLUSTERSB(12) = '1' else '0';

	QCLUSTERSB_D(22) <= '1' when QSUMB(22) > QSUMB(23) and QSUMB(22) > QSUMB(32) and QSUMB(22) > QSUMB(31) and
	                             QSUMB(22) >= QSUMB(30) and QSUMB(22) >= QSUMB(21) and QICLUSTERSB(13) = '1' else '0';

	QCLUSTERSB_D(23) <= '1' when QSUMB(23) > QSUMB(24) and QSUMB(23) > QSUMB(33) and QSUMB(23) > QSUMB(32) and
	                             QSUMB(23) >= QSUMB(31) and QSUMB(23) >= QSUMB(22) and QICLUSTERSB(14) = '1' else '0';

	QCLUSTERSB_D(24) <= '1' when QSUMB(24) > QSUMB(25) and QSUMB(24) > QSUMB(34) and QSUMB(24) > QSUMB(33) and
	                             QSUMB(24) >= QSUMB(32) and QSUMB(24) >= QSUMB(23) and QICLUSTERSB(15) = '1' else '0';

	QCLUSTERSB_D(25) <= '1' when QSUMB(25) > QSUMB(26) and QSUMB(25) > QSUMB(35) and QSUMB(25) > QSUMB(34) and
	                             QSUMB(25) >= QSUMB(33) and QSUMB(25) >= QSUMB(24) and QICLUSTERSB(16) = '1' else '0';

	QCLUSTERSB_D(26) <= '1' when QSUMB(26) > QSUMB(27) and QSUMB(26) > QSUMB(36) and QSUMB(26) > QSUMB(35) and
	                             QSUMB(26) >= QSUMB(34) and QSUMB(26) >= QSUMB(25) and QICLUSTERSB(17) = '1' else '0';

	QCLUSTERSB_D(27) <= '1' when QSUMB(27) > QSUMB(36) and QSUMB(27) >= QSUMB(35) and QSUMB(27) >= QSUMB(26) and
	                             QICLUSTERSB(18) = '1' else '0';
	
	process(CLK)
	begin
		if rising_edge(CLK) then
			QOCLUSTERSB <= QCLUSTERSB_D;
		end if;
	end process;

end RTL;