library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;  -- Use OR_REDUCE function

use work.MTriggerpkg.all;

entity QISectSum is
	port(
		CLK		: in std_logic;
		QA		: in std_logic_vector(54 downto 0);
		QB		: in std_logic_vector(54 downto 0);
		QC		: in std_logic_vector(54 downto 0);
		QSUMB	: out STD_LOGIC_VEC_ARRAY4_37
	);
end QISectSum;

architecture RTL of QISectSum is
	signal QSUMB_D		: STD_LOGIC_VEC_ARRAY4_37;
	signal QNEIGHBORSB	: STD_LOGIC_VEC_ARRAY9_37;
begin

	QNEIGHBORSB(0) <= "000" & QA(54) & QB(1 downto 0) & QA(53) & QB(4 downto 3);
	QNEIGHBORSB(1) <= "000" & QB(2 downto 0) & QB(5 downto 3);
	QNEIGHBORSB(2) <= QA(54) & QB(1 downto 0) & QA(53) & QB(4 downto 3) & QA(52) & QB(7 downto 6);
	QNEIGHBORSB(3) <= QB(2 downto 0) & QB(5 downto 3) & QB(8 downto 6);
	QNEIGHBORSB(4) <= QA(53) & QB(4 downto 3) & QA(52) & QB(7 downto 6) & QA(51) & QB(10 downto 9);
	QNEIGHBORSB(5) <= QB(5 downto 3) & QB(8 downto 6) & QB(11 downto 9);
	QNEIGHBORSB(6) <= QA(52) & QB(7 downto 6) & QA(51) & QB(10 downto 9) & QA(50) & QB(13 downto 12);
	QNEIGHBORSB(7) <= QB(8 downto 6) & QB(11 downto 9) & QB(14 downto 12);
	QNEIGHBORSB(8) <= QA(51) & QB(10 downto 9) & QA(50) & QB(13 downto 12) & QA(49) & QB(16 downto 15);
	QNEIGHBORSB(9) <= QB(11 downto 9) & QB(14 downto 12) & QB(17 downto 15);
	QNEIGHBORSB(10) <= QA(50) & QB(13 downto 12) & QA(49) & QB(16 downto 15) & QA(48) & QB(19 downto 18);
	QNEIGHBORSB(11) <= QB(14 downto 12) & QB(17 downto 15) & QB(20 downto 18);
	QNEIGHBORSB(12) <= QA(49) & QB(16 downto 15) & QA(48) & QB(19 downto 18) & QA(47) & QB(22 downto 21);
	QNEIGHBORSB(13) <= QB(17 downto 15) & QB(20 downto 18) & QB(23 downto 21);
	QNEIGHBORSB(14) <= QA(48) & QB(19 downto 18) & QA(47) & QB(22 downto 21) & QA(46) & QB(25 downto 24);
	QNEIGHBORSB(15) <= QB(20 downto 18) & QB(23 downto 21) & QB(26 downto 24);
	QNEIGHBORSB(16) <= "00" & QA(47) & QB(22 downto 21) & QA(46) & QB(25 downto 24) & QB(27);
	QNEIGHBORSB(17) <= "0" & QB(23 downto 21) & QB(26 downto 24) & QB(28 downto 27);
	QNEIGHBORSB(18) <= "000" & QB(26 downto 24) & QB(28 downto 27) & QB(37);
	
	QNEIGHBORSB(19) <= "00" & QB(29 downto 27) & QB(38 downto 37) & QB(47 downto 46);
	QNEIGHBORSB(20) <= QB(30 downto 28) & QB(39 downto 37) & QB(48 downto 46);
	QNEIGHBORSB(21) <= QB(31 downto 29) & QB(40 downto 38) & QB(49 downto 47);
	QNEIGHBORSB(22) <= QB(32 downto 30) & QB(41 downto 39) & QB(50 downto 48);
	QNEIGHBORSB(23) <= QB(33 downto 31) & QB(42 downto 40) & QB(51 downto 49);
	QNEIGHBORSB(24) <= QB(34 downto 32) & QB(43 downto 41) & QB(52 downto 50);
	QNEIGHBORSB(25) <= QB(35 downto 33) & QB(44 downto 42) & QB(53 downto 51);
	QNEIGHBORSB(26) <= QB(36 downto 34) & QB(45 downto 43) & QB(54 downto 52);
	QNEIGHBORSB(27) <= "000" & QB(36 downto 35) & QB(45 downto 44) & QB(54 downto 53);

	QNEIGHBORSB(28) <= "000" & QB(38 downto 37) & QB(47 downto 46) & QC(24) & QC(21);
	QNEIGHBORSB(29) <= QB(39 downto 37) & QB(48 downto 46) & QC(24) & QC(21) & QC(18);
	QNEIGHBORSB(30) <= QB(40 downto 38) & QB(49 downto 47) & QC(21) & QC(18) & QC(15);
	QNEIGHBORSB(31) <= QB(41 downto 39) & QB(50 downto 48) & QC(18) & QC(15) & QC(12);
	QNEIGHBORSB(32) <= QB(42 downto 40) & QB(51 downto 49) & QC(15) & QC(12) & QC(9);
	QNEIGHBORSB(33) <= QB(43 downto 41) & QB(52 downto 50) & QC(12) & QC(9) & QC(6);
	QNEIGHBORSB(34) <= QB(44 downto 42) & QB(53 downto 51) & QC(9) & QC(6) & QC(3);
	QNEIGHBORSB(35) <= QB(45 downto 43) & QB(54 downto 52) & QC(6) & QC(3) & QC(0);
	QNEIGHBORSB(36) <= "000" & QB(45 downto 44) & QB(54 downto 53) & QC(3) & QC(0);

	GEN1: for i in 0 to 36 generate
		QSUMB_D(i) <= sum_9bits(QNEIGHBORSB(i));
	end generate;
	
	process(CLK)
	begin
		if rising_edge(CLK) then
			QSUMB <= QSUMB_D;
		end if;
	end process;

end RTL;