library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_misc.all;

use work.QTriggerPKG.all;

entity QInputMask is
	port(
		MASKS_IN	: in std_logic_vector(105 downto 0);
		QTOWERS_IN	: in std_logic_vector(105 downto 0);
		QTOWERS_OUT	: out std_logic_vector(105 downto 0);
		CONFIG0		: in std_logic_vector(105 downto 0);
		CONFIG1		: in std_logic_vector(105 downto 0)
	);
end QInputMask;

architecture RTL of QInputMask is
begin

	GEN1: for i in 0 to 105 generate
		QTOWERS_OUT(i) <= QTOWERS_IN(i) when CONFIG0(i) = '0' and CONFIG1(i) = '0' else
		                  QTOWERS_IN(i) and MASKS_IN(i) when CONFIG0(i) = '1' and CONFIG1(i) = '0' else
		                 '0' when CONFIG0(i) = '0' and CONFIG1(i) = '1' else '1';
	end generate;

end RTL;