-- ****************************************************************************
-- Company:         CAEN SpA - Viareggio - Italy
-- Model:           V1495 -  Multipurpose Programmable Trigger Unit
-- FPGA Proj. Name: V1495USR_DEMO
-- Device:          ALTERA EP1C4F400C6
-- Author:          Luca Colombini
-- Date:            02-03-2006
-- ----------------------------------------------------------------------------
-- Module:          V1495USR_PKG
-- Description:     Package that implements global constants (ID Codes, 
--                  Register Addresses).
-- ****************************************************************************

-- ############################################################################
-- Revision History:
-- ############################################################################
LIBRARY ieee;
USE ieee.std_logic_1164.all;
PACKAGE v1495pkg IS
   
-- Constants
-- Expansion Mezzanine Type ID-Codes
	constant A395A : std_logic_vector(2 downto 0) := "000"; -- 32CH IN LVDS/ECL INTERFACE
	constant A395B : std_logic_vector(2 downto 0) := "001"; -- 32CH OUT LVDS INTERFACE
	constant A395C : std_logic_vector(2 downto 0) := "010"; -- 32CH OUT ECL INTERFACE
	constant A395D : std_logic_vector(2 downto 0) := "011"; -- 8CH I/O SELECT NIM/TTL INTER

-- Register Address Map

	constant A_BOARDIDS		: std_logic_vector(15 downto 0) := x"0000";
	constant A_REVISION		: std_logic_vector(15 downto 0) := x"0002";
	constant A_ERRORS		: std_logic_vector(15 downto 0) := x"0004";
	
	constant A_CONFIG0_0	: std_logic_vector(15 downto 0) := x"0010";
	constant A_CONFIG0_1	: std_logic_vector(15 downto 0) := x"0012";
	constant A_CONFIG0_2	: std_logic_vector(15 downto 0) := x"0014";
	constant A_CONFIG0_3	: std_logic_vector(15 downto 0) := x"0016";
	constant A_CONFIG0_4	: std_logic_vector(15 downto 0) := x"0018";
	constant A_CONFIG0_5	: std_logic_vector(15 downto 0) := x"001A";
	constant A_CONFIG0_6	: std_logic_vector(15 downto 0) := x"001C";
	
	constant A_CONFIG1_0	: std_logic_vector(15 downto 0) := x"0020";
	constant A_CONFIG1_1	: std_logic_vector(15 downto 0) := x"0022";
	constant A_CONFIG1_2	: std_logic_vector(15 downto 0) := x"0024";
	constant A_CONFIG1_3	: std_logic_vector(15 downto 0) := x"0026";
	constant A_CONFIG1_4	: std_logic_vector(15 downto 0) := x"0028";
	constant A_CONFIG1_5	: std_logic_vector(15 downto 0) := x"002A";
	constant A_CONFIG1_6	: std_logic_vector(15 downto 0) := x"002C";

	constant A_THRESHOLD	: std_logic_vector(15 downto 0) := x"0030";
	constant A_CLUSTCNT		: std_logic_vector(15 downto 0) := x"0032";

	constant A_TOWERS_0		: std_logic_vector(15 downto 0)	:= x"0040";
	constant A_TOWERS_1		: std_logic_vector(15 downto 0)	:= x"0042";
	constant A_TOWERS_2		: std_logic_vector(15 downto 0)	:= x"0044";
	constant A_TOWERS_3		: std_logic_vector(15 downto 0)	:= x"0046";
	constant A_TOWERS_4		: std_logic_vector(15 downto 0)	:= x"0048";
	constant A_TOWERS_5		: std_logic_vector(15 downto 0)	:= x"004A";
	constant A_TOWERS_6		: std_logic_vector(15 downto 0)	:= x"004C";

END v1495pkg;
